#!/bin/sh

dir=`pwd` ;
FQDN='example.com';
USER='david';

cd /usr/src;

echo "Downloading files...";

wget -nc http://www.qmail.org/netqmail-1.05.tar.gz &&
ncftpget ftp://cr.yp.to/ucspi-tcp/ucspi-tcp-0.88.tar.gz &&
ncftpget ftp://cr.yp.to/daemontools/daemontools-0.76.tar.gz &&
echo "Succeeded." ;


echo "Unpacking..." ;

tar -zxf netqmail-1.05.tar.gz &&
rm -f netqmail-1.05.tar.gz ;
tar -zxf ucspi-tcp-0.88.tar.gz &&
rm -f ucspi-tcp-0.88.tar.gz ; 
mkdir daemontools &&
mv daemontools-0.76.tar.gz daemontools/ &&
cd daemontools/ &&
tar -zxf daemontools-0.76.tar.gz && 
rm -f daemontools-0.76.tar.gz && 
cd .. ;


echo "Applying patches..." ;

cd netqmail-1.05 &&
./collate.sh && 
cd .. ;
cd ucspi-tcp-0.88 &&
patch < /usr/src/netqmail-1.05/other-patches/ucspi-tcp-0.88.errno.patch &&
cd .. ;
cd daemontools/admin/daemontools-0.76/src/ &&
patch < /usr/src/netqmail-1.05/other-patches/daemontools-0.76.errno.patch &&
cd .. ;

echo "Creating users and groups..." ;

mkdir /var/qmail ;

groupadd nofiles ;
useradd qmaild -g nofiles -d /var/qmail -s /bin/false -M ;
useradd alias -g nofiles -d /var/qmail/alias -s /bin/false -M ;
useradd qmaill -g nofiles -d /var/qmail -s /bin/false -M ;
useradd qmailp -g nofiles -d /var/qmail -s /bin/false -M ;
groupadd qmail ;
useradd qmailq -g qmail -d /var/qmail -s /bin/false -M ;
useradd qmailr -g qmail -d /var/qmail -s /bin/false -M ;
useradd qmails -g qmail -d /var/qmail -s /bin/false -M ;

echo "Building qmail..." ;

cd /usr/src/netqmail-1.05/netqmail-1.05/ &&
make setup check &&
./config-fast $FQDN &&
cd /usr/src ;

cd ucspi-tcp-0.88/ &&
make &&
make setup check &&
cd /usr/src ;

cd daemontools/admin/daemontools-0.76/ &&
./package/install &&
cd /usr/src ;

cd $dir/ &&
mv qmail-rc /var/qmail/rc &&
chmod 755 /var/qmail/rc &&
echo ./Maildir/ >/var/qmail/control/defaultdelivery

mkdir -p /var/log/qmail/smtpd
chown qmaill /var/log/qmail /var/log/qmail/smtpd

mkdir -p /var/qmail/supervise/qmail-send/log
mkdir -p /var/qmail/supervise/qmail-smtpd/log

mv $dir/qmailctl /var/qmail/bin/qmailctl ;
mv $dir/send-run /var/qmail/supervise/qmail-send/run ;
mv $dir/send-log-run /var/qmail/supervise/qmail-send/log/run ;
mv $dir/smtpd-run /var/qmail/supervise/qmail-smtpd/run ;
mv $dir/smtpd-log-run /var/qmail/supervise/qmail-smtpd/log/run ;

chmod 755 /var/qmail/bin/qmailctl ;
chmod 755 /var/qmail/supervise/qmail-send/run ;
chmod 755 /var/qmail/supervise/qmail-send/log/run ;
chmod 755 /var/qmail/supervise/qmail-smtpd/run ;
chmod 755 /var/qmail/supervise/qmail-smtpd/log/run ;

echo 20 > /var/qmail/control/concurrencyincoming ;
chmod 644 /var/qmail/control/concurrencyincoming ;

ln -s /var/qmail/supervise/qmail-send /var/qmail/supervise/qmail-smtpd /service
ln -s /var/qmail/bin/qmailctl /usr/bin ;

echo '127.:allow,RELAYCLIENT=""' >>/etc/tcp.smtp ;
qmailctl cdb ;

echo $USER > /var/qmail/alias/.qmail-root
echo $USER > /var/qmail/alias/.qmail-postmaster
ln -s .qmail-postmaster /var/qmail/alias/.qmail-mailer-daemon
chmod 644 /var/qmail/alias/.qmail-root /var/qmail/alias/.qmail-postmaster

echo "You should remove sendmail and create links to qmail.";
echo "";
echo "ln -s /var/qmail/bin/sendmail /usr/lib";
echo "ln -s /var/qmail/bin/sendmail /usr/sbin";
echo "";

qmailctl stat;
